multiple(N,X) :- 1 #< Z, Z #=< X, X #= N * Z.

diviseur(N,X) :- 1 #< Z, Z #=< N, N #= X * Z.

pasdansliste(_,[]).
pasdansliste(X,[X|_]) :- !,fail.
pasdansliste(X,[_|L]) :- pasdansliste(X,L).

retiredeliste(_,[],_) :- fail,!.
retiredeliste(X,[X|L],L) :- true,!.
retiredeliste(X,[Y|L],[Y|LL]) :- retiredeliste(X,L,LL).

intervalle(1,[1]) :- !.
intervalle(Max,[Max|L]) :- Max2 is Max-1, intervalle(Max2,L).

longueur([],0).
longueur([_|L],N) :- longueur(L,NN), N is NN+1.

suivant(Max,X,Suiv,Liste) :- intervalle(Max,L), findall(N,(member(N,L),multiple(X,N)),Possibles), member(Suiv,Possibles), pasdansliste(Suiv,Liste).
suivant(Max,X,Suiv,Liste) :- intervalle(Max,L), findall(N,(member(N,L),diviseur(X,N)),Possibles), member(Suiv,Possibles), pasdansliste(Suiv,Liste).

suite(_,Courant,_,[Courant]).
suite(Max,Suivant,Interdits,[Suivant|Liste]) :- suivant(Max,Suivant,Courant,Interdits), suite(Max,Courant,[Suivant|Interdits],Liste).

recopie([]).
recopie([X|L]) :- write(X), nl, recopie(L).

pls(Max,N) :- intervalle(Max,L), member(Init,L), suite(Max,Init,[],Liste), longueur(Liste,N), recopie(Liste), !.
pls(Max,N) :- NN is N-1, pls(Max,NN).

pls_init(Max,Init,N) :- suite(Max,Init,[],Liste), longueur(Liste,N), recopie(Liste), !.
pls_init(Max,Init,N) :- NN is N-1, pls_init(Max,Init,NN).

plus_longue_suite(Max) :- pls(Max,Max).
